/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


/*
* ============================================================================
*  Name     : CContext_logDocument from Context_logDocument.h
*  Part of  : context_log
*  Created  : 13.2.2003 by 
*  Implementation notes:
*     Initial content was generated by Series 60 AppWizard.
*  Version  :
*  Copyright: 
* ============================================================================
*/

// INCLUDE FILES
#include "Context_logDocument.h"
#include "Context_logAppUi.h"
#include "app_context.h"
#include "settings.h"
#include "cl_settings.h"

// ================= MEMBER FUNCTIONS =======================

// constructor
CContext_logDocument::CContext_logDocument(CEikApplication& aApp)
: CAknDocument(aApp)    
{
}

// destructor
CContext_logDocument::~CContext_logDocument()
{
	delete iContext;
}

// EPOC default constructor can leave.
void CContext_logDocument::ConstructL()
{
	iContext=CApp_context::NewL(false, _L("context_log"));
	iContext->SetDataDir(_L("c:\\system\\data\\context\\"), false);

#ifndef __WINS__
	TParsePtrC parse(Application()->DllName());
	iContext->SetAppDir(parse.DriveAndPath());
#else
	iContext->SetAppDir(_L("c:\\system\\apps\\context_log\\"));
#endif

	CSettings* s=CSettings::NewL(*iContext, iDefaultSettings, _L(""));
	iContext->SetSettings(s);
	
}

// Two-phased constructor.
CContext_logDocument* CContext_logDocument::NewL(
						 CEikApplication& aApp)     // CContext_logApp reference
{
	CContext_logDocument* self = new (ELeave) CContext_logDocument( aApp );
	CleanupStack::PushL( self );
	self->ConstructL();
	CleanupStack::Pop();
	
	return self;
}

// ----------------------------------------------------
// CContext_logDocument::CreateAppUiL()
// constructs CContext_logAppUi
// ----------------------------------------------------
//
CEikAppUi* CContext_logDocument::CreateAppUiL()
{
	return new (ELeave) CContext_logAppUi(*iContext);
}

// End of File  
